unit newshape;

Interface

uses vga256d;

const
   OldBlack = 0;
   NewBlack = 253;
   maximumshape = 151;
   maxtable = 8;
   _PlanetShapes    = 1;
   _FontShapes      = 2;
   _SmallFontShapes = 3;
   _FaceShapes      = 4;
   _OptionShapes    = 5;   {Also contains help shapes}
   _TinyFont        = 6;
   _WeaponShapes    = 7;
   _ExtraShapes     = 8;   {Used for Ending pics}

type
   shapearraytype = array[1..maxtable,1..maximumshape] of pointer;
var
   LoadOverride : boolean;
   min,max : word;

   tempscreenseg : word;

   shapearray : ^shapearraytype;

   shapex,shapey : array[1..maxtable,1..maximumshape] of word;
   shapesize : array[1..maxtable,1..maximumshape] of word;
   shapexist : array[1..maxtable,1..maximumshape] of boolean;

   maxshape : array[1..maxtable] of byte;

   mousegrabshape : array[1..24*28] of byte;

   x : byte;

{
  Colors:
  253 : Black
  254 : Jump to next line

   Skip X Pixels
   Draw X pixels of color Y
}

procedure Newloadshapes (table : byte; shapefile : string);
procedure NewLoadShapesB (table : byte; var f : file);
procedure NewCompressBlock (var shape : pointer; xsize,ysize : word; var shapesize : word );
procedure NewDrawShape (shape : pointer; xsize,ysize : word );
procedure NewDrawCShape (shape : pointer; xsize,ysize : word );
procedure NewDrawCShapeNum (table : byte; shape : byte; x,y : word );
procedure NewPurgeShapes (table : byte);
{procedure OverrideLoadShapes ( table : byte; shapefile : string; minimum,maximum : word );}

procedure drawshapetypeone( x,y,shapeofs,shapeseg:word);
procedure grabshapetypeone( x,y,shapeofs,shapeseg:word);

var Shapes6Ofs,Shapes6Seg : word;

Implementation

procedure drawshapetypeone( x,y,shapeofs,shapeseg:word); assembler;
asm
   push ds
   mov  es,VGAScreenSeg

   mov di,y
   shl di,6
   mov ax,di
   shl ax,2
   add di,ax
   add di,x

   sub  ch,ch

   mov  si,ShapeOfs
   mov  ds,ShapeSeg

mov bh,28
@Yloop:
   mov  cl,24
   rep movsb
   add di,320-24
   dec bh
   jnz @Yloop

   pop ds
end;

procedure grabshapetypeone( x,y,shapeofs,shapeseg:word); assembler;
asm
   push ds

   mov si,y
   shl si,6
   mov ax,si
   shl ax,2
   add si,ax
   add si,x

   sub  ch,ch

   mov  di,ShapeOfs
   mov  es,ShapeSeg

   mov  ds,VGAScreenSeg

mov bh,28
@Yloop:
   mov  cl,24
   rep movsb
   add si,320-24
   dec bh
   jnz @Yloop

   pop ds
end;

procedure NewDrawCShape (shape : pointer; xsize,ysize : word );
var
   a,b,c : word;

   tempseg,tempofs : word;
begin
    tempseg:=seg(shape^);
    tempofs:=ofs(shape^);

    a:=xsize;
    b:=ysize;
    c:=2+2*320;  { Location to Draw }

    asm
    push ds
    push bp
       mov dx,320
       sub dx,a

       mov bx,b

       mov di,c
       mov cx,tempScreenSeg
       mov es,cx

       mov si,tempofs
       mov cx,tempseg

       mov bp,a
       mov ds,cx

       sub ah,ah

       (* Copy Shape *)
       jmp @Yloop

    @Yskip:
       cmp bh,255
       je  @drawblack
       inc si
       add di,cx
       add di,dx
       dec bl
       jz  @enddraw
       jmp @Yloop

    @drawblack:
       inc si
       mov al,ds:[si]
       add di,ax
       sub cx,ax
       inc si
       jmp @Xloop

    @Yloop:
       mov cx,bp

       @Xloop:

       mov bh,ds:[si]
       cmp bh,253  {NewBlack}
       je  @Nodraw
       ja  @Yskip

       mov es:[di],bh

    @Nodraw:
       inc si
       inc di

       loop @Xloop

       add di,dx

       dec bl
       jnz @Yloop

    @enddraw:
    pop bp
    pop ds
    end;
    tempscreenseg:=vgascreenseg;
end;


procedure NewCompressBlock (var shape : pointer; xsize,ysize : word; var shapesize : word );
var
   tempbuffer : ^screentype;

   tempofs, tempseg, bufofs, bufseg : word;
   temp,temp2 : byte;

   x,y,xdraw,pos : word;

   foundblack : boolean;
   blackcount : byte;

   tempstr : string;

   newsize : word;

procedure drawnext ( draw : byte );
begin
{   str(draw,tempstr);
   outovertext(xdraw * 20,y * 8 + 100,tempstr,188);}
   inc(newsize);
   inc(xdraw);

   mem[bufseg:bufofs]:=draw;
   inc(bufofs);
end;

procedure DrawNShape (shape : pointer; xsize,ysize : word );
var
   a,b,c : word;

   tempseg,tempofs : word;
begin
    tempseg:=seg(shape^);
    tempofs:=ofs(shape^);

    a:=xsize;
    b:=ysize;
    c:=2+2*320;  { Location to Draw }

    asm
    push ds
       mov ax,a
       mov dx,320
       sub dx,ax

       mov bx,b

       mov di,c
       mov cx,VGAScreenSeg
       mov es,cx

       mov si,tempofs
       mov cx,tempseg
       mov ds,cx

       (* Copy Shape *)

    @Yloop:
       mov cx,ax

       @Xloop:

       mov bh,ds:[si]
       cmp bh,OldBlack
       je  @Nodraw

       mov es:[di],bh

    @Nodraw:
       inc si
       inc di

       dec cx
       jnz @Xloop

       add di,dx

       dec bl
       jnz @Yloop
    pop ds
    end;
end;

procedure NewDrawCShape (shape : pointer; xsize,ysize : word );
var
   a,b,c : word;

   tempseg,tempofs : word;
begin
    tempseg:=seg(shape^);
    tempofs:=ofs(shape^);

    a:=xsize;
    b:=ysize;
    c:=160+2*320;  { Location to Draw }

    asm
    push ds
    push bp
       mov dx,320
       sub dx,a

       mov bx,b

       mov di,c
       mov cx,VGAScreenSeg
       mov es,cx

       mov si,tempofs
       mov cx,tempseg

       mov bp,a
       mov ds,cx

       sub ah,ah

       (* Copy Shape *)
       jmp @Yloop

    @Yskip:
       cmp bh,255
       je  @drawblack
       inc si
       add di,cx
       add di,dx
       dec bl
       jz  @enddraw
       jmp @Yloop

    @drawblack:
       inc si
       mov al,ds:[si]
       add di,ax
       sub cx,ax
       inc si
       jmp @Xloop

    @Yloop:
       mov cx,bp

       @Xloop:

       mov bh,ds:[si]
       cmp bh,253  {NewBlack}
       je  @Nodraw
       ja  @Yskip

       mov es:[di],bh

    @Nodraw:
       inc si
       inc di

       loop @Xloop

       add di,dx

       dec bl
       jnz @Yloop

    @enddraw:
    pop bp
    pop ds
    end;
end;

begin
 shapesize:=0;
 if shape<>nil then begin

   new(tempbuffer);

   tempofs:=ofs(shape^);
   tempseg:=seg(shape^);
   bufofs:=ofs(tempbuffer^);
   bufseg:=seg(tempbuffer^);

   clr256;

   x:=0; xdraw:=0;
   y:=0; pos:=tempofs;
   foundblack := false;

   newsize:=0;

   repeat
      temp := mem[tempseg:pos];
      inc(pos);

{      str(temp,tempstr);
      outtext(x*20,y*8,tempstr,199);}

      {Check for Black}
      if temp=OldBlack then
         if FoundBlack then
            inc(blackcount)
         else
            begin
               FoundBlack:=true;
               BlackCount:=1;
            end
      else
         if FoundBlack then begin
            if BlackCount<3 then begin
               for temp2:=1 to BlackCount do drawnext(NewBlack);
            end else begin
               drawnext(255); drawnext(blackcount);
            end;

            FoundBlack:=false;    {This would be color 255}
            drawnext(temp);
         end else begin
            drawnext(temp);
         end;

      inc(x);

      if x=(xsize) then begin
         if FoundBlack then
           if blackcount>1 then begin drawnext(254); FoundBlack:=false; end
            else begin drawnext(NewBlack); FoundBlack:=false; end;
         x:=0; xdraw:=0;
         inc(y);
      end;

      {showvga;}

   until (y=ysize);

{   str(xsize*ysize,tempstr);
   outtext(2,192,'OLD SIZE  '+tempstr,199);
   str(newsize,tempstr);
   outtext(162,192,'NEW SIZE  '+tempstr,199);
   str(100-round(newsize/(xsize*ysize)*100),tempstr);
   outtext(290,192,'+'+tempstr+'%',199);}
   showvga;

   bar(0,0,319,50,2);

   for x:=1 to 1 do NewdrawCShape(tempbuffer,xsize,ysize);
   for x:=1 to 1 do DrawNShape(shape,xsize,ysize);
   showvga;

   getk(k);

   dispose(shape);

   getmem(shape,newsize);

   tempofs:=ofs(shape^);
   tempseg:=seg(shape^);
   bufofs:=ofs(tempbuffer^);
   bufseg:=seg(tempbuffer^);

   asm
   push ds
      mov cx,newsize

      mov ax,tempseg
      mov es,ax
      mov di,tempofs

      mov si,bufofs
      mov ax,bufseg
      mov ds,ax

   @copyloop:
      movsb

      loop @copyloop
   pop ds
   end;

   dispose(tempbuffer);

   shapesize:=newsize;
 end;
end;

procedure NewDrawShape (shape : pointer; xsize,ysize : word );
var
   a,b,c : word;

   tempseg,tempofs : word;
begin
    tempseg:=seg(shape^);
    tempofs:=ofs(shape^);

    a:=xsize;
    b:=ysize;
    c:=2+2*320;  { Location to Draw }

    asm
    push ds
       mov ax,a
       mov dx,320
       sub dx,ax
       shr ax,1

       mov bx,b

       mov di,c
       mov cx,VGAScreenSeg
       mov es,cx

       mov si,tempofs
       mov cx,tempseg
       mov ds,cx

       (* Copy Shape *)

    @Yloop:
       mov cx,ax

       rep movsw

       add di,dx

       dec bx
       jnz @Yloop
    pop ds
    end;
end;


procedure Newpurgeshapes (table : byte);
var x : word;
begin
if maxshape[table]>0 then 
 for x:=1 to maxshape[table] do
    if shapexist[table,x] then begin
       freemem(shapearray^[table,x],shapesize[table,x]);
       shapexist[table,x]:=false;
    end;
end;

procedure NewLoadShapesB (table : byte; var f : file);
var
   tempw : word;
   z : word;
begin
      blockread(f,tempw,2);
      maxshape[table]:=tempw;

      if not LoadOverride then begin
         min:=1; max:=maxshape[table];
      end;

      if min>1 then begin
         for z:=1 to min-1 do begin
            blockread(f,shapexist[table,z],1);

            if shapexist[table,z] then begin
               blockread(f,shapex   [table,z],2);
               blockread(f,shapey   [table,z],2);
               blockread(f,shapesize[table,z],2);

               getmem(shapearray^[table,z],shapex[table,z]*shapey[table,z]);

               blockread(f,shapearray^[table,z]^,shapesize[table,z]);

               freemem(shapearray^[table,z],shapex[table,z]*shapey[table,z]);
            end;
         end;
      end;

     for z:=min to max do begin
      tempw:=z-min+1;
      blockread(f,shapexist[table,tempw],1);

      if shapexist[table,tempw] then begin
         blockread(f,shapex   [table,tempw],2);
         blockread(f,shapey   [table,tempw],2);
         blockread(f,shapesize[table,tempw],2);

         getmem(shapearray^[table,tempw],shapex[table,tempw]*shapey[table,tempw]);

         blockread(f,shapearray^[table,tempw]^,shapesize[table,tempw]);
      end;
     end;
end;

procedure Newloadshapes (table : byte; shapefile : string);
var
   f : file;
begin
   newpurgeshapes(table);

      assign(f,shapefile);
      reset(f,1);

      NewLoadShapesB(table,f);

      close(f);

  { debuginfo('Shape table '+shapefile+' finished'+#13);}
end;

{procedure OverrideLoadShapes ( table : byte; shapefile : string; minimum,maximum : word );
begin
   LoadOverride := true;
   min:=minimum; max:=maximum;
   NewLoadShapes(table,shapefile);
   LoadOverride := false;
end;}

procedure NewDrawCShapeNum (table : byte; shape : byte; x,y : word );
var
   a,b,c : word;

   tempseg,tempofs : word;
begin
   if (shape>maxshape[table]) or (not shapexist[table,shape]) or
      (shape=0) then halt(99);

    tempseg:=seg(shapearray^[table,shape]^);
    tempofs:=ofs(shapearray^[table,shape]^);

    a:=shapex[table,shape];
    b:=shapey[table,shape];
    c:=x+y*320;  { Location to Draw }

    asm
    push ds
    push bp
       mov dx,320
       sub dx,a

       mov bx,b

       mov di,c
       mov cx,tempscreenseg
       mov es,cx

       mov si,tempofs
       mov cx,tempseg

       mov bp,a
       mov ds,cx

       sub ah,ah

       (* Copy Shape *)
       jmp @Yloop

    @Yskip:
       cmp bh,255
       je  @drawblack
       inc si
       add di,cx
       add di,dx
       dec bl
       jz  @enddraw
       jmp @Yloop

    @drawblack:
       inc si
       mov al,ds:[si]
       add di,ax
       sub cx,ax
       inc si
       jmp @Xloop

    @Yloop:
       mov cx,bp

       @Xloop:

       mov bh,ds:[si]
       cmp bh,253  {NewBlack}
       je  @Nodraw
       ja  @Yskip

       mov es:[di],bh

    @Nodraw:
       inc si
       inc di

       loop @Xloop

       add di,dx

       dec bl
       jnz @Yloop

    @enddraw:
    pop bp
    pop ds
    end;
   tempscreenseg:=vgascreenseg;
end;


begin
   loadoverride:=false;
   tempscreenseg:=vgascreenseg;
   for x:=1 to maxtable do maxshape[x]:=0;
   new(shapearray);
end.