unit params;
interface
uses dos;

var
   TimMode,RichMode,RecordDemo,

   RobertWeird,ConstantPlay,ConstantDie,

   ScanForJoystick,UseBios,NoSound,QuikJuke,NoRetrace,JoyMax,ForceAveraging,

   ForceMaxVolume,SoundInfoReport : boolean;
   StupidWindows : boolean;

   {Special Note:
     The two booleans to detect network play for Tim's stuff.
     It's in here because of the dumb port 60 bug. }
   IsNetworkGame,IsNetworkActive : boolean;

   TyrianXmas : boolean;

const
   Pars : array [1..18] of string[8] =
    ('LOOT','BORDER','RECORD','NOJOY','NOROBERT','CONSTANT','DEATH','NOKEY','NOSOUND','JUKEBOX',
     'MAXVOL','SOUND?','FLICKER','JOYMAX','WEAKJOY','NOWINCHK','NOXMAS','YESXMAS');

procedure ParamCheck;

implementation

procedure ParamCheck;
var
tempstr : string[8];
x,y : word;

begin
robertweird     :=true;
richmode        :=false;
timmode         :=false;
recorddemo      :=false;
scanforjoystick :=true;
constantplay    :=false;
usebios         :=false;
nosound         :=false;
quikjuke        :=false;
forcemaxvolume  :=false;
soundinforeport :=false;
noretrace       :=false;
joymax          :=false;
forceaveraging  :=true;

GetDate (x,y,x,x);
TyrianXMAS:=(y=12);

{Note:
  Parameters are no longer case-sensitive.

LOOT    - Gives you mucho bucks.
BORDER   - Network border mode (useless)
NOROBERT - Alternate selection of items in upgrade menu.
RECORD   - Records all level and stores the last one in DEMOREC.num file
           (When a file is taken, it increments "num" until no file is found)

        Note: Mouse and Joystick are disabled when recording.

NOJOY    - Disables joystick detection
NOKEY    - Forces Tyrian to send keys to the BIOS just in case some other
           device driver needs input.  It still uses the keyboard input
           driver, though.

CONSTANT - Constant play for testing purposes (C key activates invincibility)
           This might be useful for publishers to see everything - especially
           those who can't play it.

DEATH    - Constant death mode.  Only useful for testing.

NOSOUND  - Disables Sound/Music usage even if FX or Music are in the config
           file.  It tells the initialization routine to NEVER check for
           initialization and will not load the Sound Effects, saving memory
           in SETUP.
           FM sound will still be automatically detected since I have no
           control over that.
           You can, however, select sound and music selections that would
           otherwise not work and it won't return an error since it does
           not try to detect them.  This might help if someone has a problem
           only in SETUP and not in Tyrian.

JUKEBOX  - Only works in SETUP.  Takes you directly to the jukebox.

MAXVOL   - Force Tyrian or SETUP to set the card's main volume to maximum
           if it is able to instead of reading the current value.

SOUND?   - Display IRQ/DMA junk so Andreas has more info.  Only works in SETUP.
           This will save a file called SOUND.RPT to your HD detailing your
           sound selections and any initialization errors for convenient
           uploading on CServe/AOL/Internet.

FLICKER  - This will force Tyrian and SETUP to NEVER WAIT FOR A RETRACE.
           Might be helpful for unknown reasons.  Perhaps a sound card is
           cutting out for some related reason?    [V1.2]

JOYMAX   - Sets your joystick to maximum sensitivity.   [V1.2]
}

for x:=1 to paramcount do begin
 tempstr:=paramstr(x);
 for y:=1 to 10 do tempstr[y]:=upcase(tempstr[y]);

 for y:=1 to 18 do if tempstr=pars[y] then
 case y of
 1 : richmode:=true;
 2 : timmode:=true;
 3 : begin recorddemo:=true; writeln('Use a keyboard to record a demo.'); end;
 4 : scanforjoystick:=false;
 5 : robertweird:=false;
 6 : constantplay:=true;
 7 : constantdie:=true;
 8 : begin usebios:=true; writeln('Keyboard redirection disabled.'); end;
 9 : nosound:=true;
10 : QuikJuke:=true;
11 : ForceMaxVolume:=true;
12 : SoundInfoReport:=true;
13 : NoRetrace:=true;
14 : JoyMax:=true;
15 : ForceAveraging:=true; 
16 : stupidwindows:=false;
17 : TyrianXMAS:=false;
18 : TyrianXMAS:=true;
 end;
end;
end;

end.
