
unit terrbrsh;

interface
uses dos;
const
   maxbrushx = 32;
   maxbrushy = 32;
type
   BrushDataType = array[1..MaxBrushX,1..MaxBrushY] of word;
   BrushFlipType = array[1..MaxBrushX,1..MaxBrushY] of byte;

var              {0 = Temporary Brush    1-100=Normal Brushes   101=Temp Workspace Brush}
   brush      : array[0..101] of ^BrushDataType;
   brushfliph : array[0..101] of ^BrushFlipType;
   brushflipv : array[0..101] of ^BrushFlipType;

   brushxsize : array[0..101] of byte;
   brushysize : array[0..101] of byte;

   brushmax : word;

procedure SaveBrushes;
procedure LoadBrushes;

procedure DeleteBrush ( B : word );

implementation

procedure DeleteBrush ( B : word );
var
   temp : word;
begin
if B<BrushMax then begin
   for temp:=B+1 to BrushMax do begin
   Brush[temp-1]^:=Brush[temp]^;
   BrushFlipH[temp-1]^:=BrushFlipH[temp]^;
   BrushFlipV[temp-1]^:=BrushFlipV[temp]^;
   BrushXSize[temp-1]:=BrushXSize[temp];
   BrushYSize[temp-1]:=BrushYSize[temp];
   end;
end;
dispose(Brush[BrushMax]);
dispose(BrushFlipH[BrushMax]);
dispose(BrushFlipV[BrushMax]);
BrushXSize[BrushMax]:=0;
dec(BrushMax);
end;

procedure SaveBrushes;
var
fi : file;
x  : word;
begin
assign(fi,'TerrBrsh.dat');
rewrite(fi,1);
blockwrite(fi,brushmax,sizeof(brushmax));

for x:=1 to BrushMax do begin
blockwrite(fi,brush[x]^,sizeof(brush[x]^));
blockwrite(fi,brushfliph[x]^,sizeof(brushfliph[x]^));
blockwrite(fi,brushflipv[x]^,sizeof(brushflipv[x]^));
blockwrite(fi,brushxsize[x],sizeof(brushxsize[x]));
blockwrite(fi,brushysize[x],sizeof(brushysize[x]));
end;

close(fi);
end;

procedure LoadBrushes;
var
fi : file;
x : byte;
filelist : searchrec;
begin
brushmax:=0;
new(Brush[0]); new(BrushFlipH[0]); new(BrushFlipV[0]);
BrushXSize[0]:=0;
BrushYSize[0]:=0;

findfirst('TerrBrsh.dat',$3F,filelist);

if DosError=0 then begin
assign(fi,'TerrBrsh.dat');
reset(fi,1);
blockread(fi,brushmax,sizeof(brushmax));

for x:=1 to BrushMax do begin
new(Brush[x]); new(BrushFlipH[x]); new(BrushFlipV[x]);
blockread(fi,brush[x]^,sizeof(brush[x]^));
blockread(fi,brushfliph[x]^,sizeof(brushfliph[x]^));
blockread(fi,brushflipv[x]^,sizeof(brushflipv[x]^));
blockread(fi,brushxsize[x],sizeof(brushxsize[x]));
blockread(fi,brushysize[x],sizeof(brushysize[x]));
end;

close(fi);
end;
end;



begin
LoadBrushes;

{Initialize Workspace Brush}
new(Brush[101]); new(BrushFlipH[101]); new(BrushFlipV[101]);

end.