
program TerrainEdit;

uses crt,vga256d,pcxload,texload,mouse,starfade,pallib,newshape,terrbrsh;

const
DrawModeName : array[1..4] of string[10] =
 ('Height','Tile','?','?');

MapXVisibleArea : word = 276;

type
TerrainRow = array[1..256] of byte;
TerrainHeightType = array[1..256] of ^TerrainRow;
TextureMapType = array[1..128,1..128] of byte;

TerrainDataRow = array[1..256] of word;
TerrainDataType = array[1..256] of ^TerrainRow;

var
TerrainFlipH : TerrainHeightType;
TerrainFlipV : TerrainHeightType;
TerrainHeight : TerrainHeightType;
TerrainData : TerrainDataType;
RaiseLowerRadius : byte;
ZoomScale : byte;

MouseColor : byte;  { Color for drawing the mouse pointer }

TextureMaps : array[1..1024] of ^TextureMapType;


var
VGAScreen2 : ScreenPtr;
x,y : word;

Temp,Temp2 : word;

Keypress : boolean;

mapx,mapy : word; {Starting Upper-left coordinate of drawn map location }

procedure BuildGrayscale;
begin
for x:=0 to 255 do begin
Colors2[x].r:=round(63 * (x/255) );
Colors2[x].g:=round(63 * (x/255) );
Colors2[x].b:=round(63 * (x/255) );
end;
{or x:=0 to 15 do begin
Colors2[240+x].r:=round(63 * (x/16) );
Colors2[240+x].g:=round(63 * (x/16) /2);
Colors2[240+x].b:=0;
end;}
{Colors2:=palettes^[1];}
MouseColor := 254;
end;

procedure ChangeTerrain ( x,y : integer; change : integer );

procedure Modify (var t : byte; c : shortint);
begin
    if (integer(t)+c < 0) then t:=0 else
    if (integer(t)+c > 255) then t:=255 else
    inc(t,c);
end;

procedure DirtFill (var h : byte; a,b,c : byte);
function DirtFillAmount (original,new : integer) : integer;
begin
     if original<new then DirtFillAmount:=round((original-new/5)+0.6)
     else DirtFillAmount:=-round(new-original/5+0.6);
     DirtFillAmount:=original;
end;
begin
    if h < (a+b/2+c/3) then Modify(h,DirtFillAmount(h,round((a+b/2+c/3))));
end;

var
   a,b : integer;
   temp : integer;
begin
    Modify (TerrainHeight[x]^[y],change);

    if RaiseLowerRadius>1 then begin
    temp:=round(RaiseLowerRadius*1.2);
    for a:=1 to 256 do for b:=1 to 256 do               { Radius Fill }
    if abs(x-a)+abs(y-b) <= temp then
    if sqrt(abs(sqr(x-a)+sqr(y-b))) <= RaiseLowerRadius then begin
    Modify (TerrainHeight[a]^[b],
      round(change*(RaiseLowerRadius-sqrt(sqr(x-a)+sqr(y-b))/RaiseLowerRadius) + random(3)-1) );
    end;
    end;

(*    for a:=1 to 256 do for b:=1 to 256 do               { Radius Dirt }
    if abs(x-a)+abs(y-b) <= RaiseLowerRadius*2 then
    if sqrt(abs(sqr(x-a)+sqr(y-b))) <= (RaiseLowerRadius*1.5) then begin
    {Dirt Smooth Towards Center}
    if (a<x) then
       if (b<y) then
          DirtFill(TerrainHeight[a]^[b],TerrainHeight[a+1]^[b],TerrainHeight[a]^[b+1],TerrainHeight[a+1]^[b+1])
       else
          DirtFill(TerrainHeight[a]^[b],TerrainHeight[a+1]^[b],TerrainHeight[a]^[b-1],TerrainHeight[a+1]^[b-1]);

    Modify (TerrainHeight[a]^[b],
      round(change*(RaiseLowerRadius-sqrt(sqr(x-a)+sqr(y-b))/(RaiseLowerRadius*1.5)) + random(3)-1) );
    end;*)
end;

{Draw Texture Map Onto Screen}
procedure DrawTex (X,Y : word; TexNum : byte; Shade : integer;
                   Scale : byte; FlipH,FlipV : boolean);
var a,b : word;  temp : byte; shiftamount : byte;
    H,V : integer;
    DX,DXs,DY,DYs : word;
begin
  case Scale of
      64 : ShiftAmount:=1;
      32 : ShiftAmount:=2;
      16 : ShiftAmount:=4;
       8 : ShiftAmount:=8;
       4 : ShiftAmount:=16;
       2 : ShiftAmount:=32;
       1 : ShiftAmount:=64;
  end;
  if fliph then begin
     DXs := 65;
     H  := -ShiftAmount;
  end else begin
     DXs := 0;
     H  := ShiftAmount;
  end;
  if flipv then begin
     DYs := 65;
     V  := -ShiftAmount;
  end else begin
     DYs := 0;
     V  := ShiftAmount;
  end;

  if TexNum=0 then
   bar(X,Y,X+Scale-1,Y+Scale-1,0)
  else begin
   dx:=dxs;
   for a:=1 to Scale do begin
   DY:=DYs;
   inc(dx,h);
   for b:=1 to Scale do begin
       inc(dy,v);
       temp:=Tex[TexNum]^[dy,dx];
       asm
          mov al,temp
          mov bx,shade
          mov ch,al
          and ax,$001F
          add ax,bx
          and ch,$E0
          cmp ax,0
          jge @NotZero
          sub ax,ax
          sub ch,ch
       @NotZero:
          cmp ax,$1F
          jle @NotTooBright
          mov ax,$1F
       @NotTooBright:
          add ch,al
          mov temp,ch
       end;
       pix(X+a-1,Y+b-1,temp);
   end;
   end;
   end;
end;
{End of DrawTex routine}

procedure DrawBrushIcon ( B : byte; X,Y : word; Brightness : byte );
var
xa,xb,ya,yb : word;
temp : word;
begin
           xb:=BrushxSize[B];
     if (xb>0) and (Brush[B]<>nil) then begin

           yb:=BrushySize[B];
           temp:=16;

           if (xb>2) or (yb>2) then begin
             temp:=8;
             if (xb>4) or (yb>4) then begin
                temp:=4;
                if (xb>8) or (yb>8) then begin
                   temp:=2;
                   if (xb>16) or (yb>16) then
                   temp:=1;
                end;
             end;
           end;

           for xa:=1 to xb do
           for ya:=1 to yb do
           DrawTex(X+xa*temp-temp,Y+ya*temp-temp,
                Brush[B]^[xa,ya],
                brightness,
                temp,
                boolean(BrushFlipH[B]^[xa,ya]),
                boolean(BrushFlipV[B]^[xa,ya])
                );
     end;
end;

function GetTileType ( tile : word; h,v : byte ) : byte;
var a : byte;
    temp : byte;
begin
   temp:=0;
   for a:=1 to 6 do if TileSet[a]=tile then temp:=a;

 {  writeln(temp,' ',v,' ',h);}
   case temp of
   0 : GetTileType := 14;
   1 : GetTileType := 13;
   2 : GetTileType := 14;
   3 : if h=1 then GetTileType:=6 else GetTileType := 5;
   4 : if v=1 then GetTileType:=7 else GetTileType := 8;
   5 : if (h=1) and (v=1) then GetTileType:=4 else
       if (h=1) then GetTileType:=2 else
       if (v=1) then GetTileType:=3 else
       GetTileType:=1;
   6 : if (h=1) and (v=1) then GetTileType:=12 else
       if (h=1) then GetTileType:=10 else
       if (v=1) then GetTileType:=11 else
       GetTileType:=9;
   end;
end;

procedure SetSmoothingTile (x,y : word; tile,h,v : word);
var
   temp : byte;
begin
   temp:=GetTileType(TerrainData[x]^[y],0,0);
   if temp=14 then begin
   TerrainData [x]^[y]:=tile;
   TerrainFlipH[x]^[y]:=h;
   TerrainFlipV[x]^[y]:=v;
   end else
   if (temp>8) and (temp<13) then
   TerrainData [x]^[y]:=tileset[1];
end;

procedure DrawSmoothingTile (x,y : word);
const
   Tile : array[1..14,1..8] of byte =
   (
    (1,0,0,1,0,0,0,0), {1}
    (0,1,0,0,0,0,1,0),
    (0,0,1,0,0,1,0,0),
    (0,0,0,0,1,0,0,1),
    (1,0,1,1,0,1,0,0), {5}
    (0,1,0,0,1,0,1,1),
    (0,0,1,0,1,1,0,1), {7}
    (1,1,0,1,0,0,1,0),
    (1,1,1,1,0,1,1,0), {9}
    (1,1,0,1,1,0,1,1),
    (1,0,1,1,1,1,0,1),
    (0,1,1,0,1,1,1,1),
    (1,1,1,1,1,1,1,1),
    (0,0,0,0,0,0,0,0)
    );

    NewTile : array[1..14,1..8] of byte =
   (
    (0,0,0,0,0,1,1,0), {1}
    (0,0,0,1,1,0,0,0),
    (1,0,0,0,0,0,0,1),
    (0,1,1,0,0,0,0,0),
    (1,0,0,0,0,1,1,1), {5}
    (0,1,1,1,1,0,0,0),
    (0,0,0,1,1,1,1,0),
    (1,1,1,0,0,0,0,1),
    (1,0,0,1,1,1,1,1), {9}
    (0,1,1,1,1,1,1,0),
    (1,1,1,0,0,1,1,1),
    (1,1,1,1,1,0,0,1),
    (1,1,1,1,1,1,1,1),
    (0,0,0,0,0,0,0,0)
   );

var
   FillTile : array[1..8] of byte;
   Match,MatchVal,TempVal : byte;
   a,b : byte;
   TileToAdd,FlipH,FlipV : word;

   WasAvailableTile : boolean;

begin
if (x>0) and (y>0) and (x<257) and (y<257) then begin
WasAvailableTile:=GetTileType(TerrainData[x]^[y],0,0)<>14;
   for a:=1 to 8 do FillTile[a]:=0;
   if y>1 then begin
      Match:=GetTileType(TerrainData[x]^[y-1],
                        TerrainFlipH[x]^[y-1],
                        TerrainFlipV[x]^[y-1]);
      {write(' Above:',Match);}
      FillTile[1]:=Tile[Match,1];
      FillTile[2]:=Tile[Match,2];
   end;
   if x>1 then begin
      Match:=GetTileType(TerrainData[x-1]^[y],
                        TerrainFlipH[x-1]^[y],
                        TerrainFlipV[x-1]^[y]);
      {write(' Left:',Match);}
      FillTile[7]:=Tile[Match,7];
      FillTile[8]:=Tile[Match,8];
   end;
   if x<256 then begin
      Match:=GetTileType(TerrainData[x+1]^[y],
                        TerrainFlipH[x+1]^[y],
                        TerrainFlipV[x+1]^[y]);
      {write(' Right:',Match);}
      FillTile[3]:=Tile[Match,3];
      FillTile[4]:=Tile[Match,4];
   end;
   if y<256 then begin
      Match:=GetTileType(TerrainData[x]^[y+1],
                        TerrainFlipH[x]^[y+1],
                        TerrainFlipV[x]^[y+1]);
      {writeln(' Below:',Match);}
      FillTile[5]:=Tile[Match,5];
      FillTile[6]:=Tile[Match,6];
   end;

{   for a:=1 to 8 do
   write(FillTile[a],' ');
   writeln;
   k:=readkey;}

   {Find Tile to Add}
   Match:=14;  MatchVal:=0;
   for a:=1 to 14 do begin
   tempval:=0;
   for b:=1 to 8 do begin
      if (FillTile[b]=NewTile[a,b]) and (NewTile[a,b]=1) then inc(tempval);
   end;
   if TempVal>MatchVal then begin Match:=a; MatchVal:=TempVal; end;
   end;

{   writeln(Match);}
   {Add Tile Back In}
   case Match of
   1 : begin TileToAdd:=5; FlipH:=0; FlipV:=0; end;
   2 : begin TileToAdd:=5; FlipH:=1; FlipV:=0; end;
   3 : begin TileToAdd:=5; FlipH:=0; FlipV:=1; end;
   4 : begin TileToAdd:=5; FlipH:=1; FlipV:=1; end;
   5 : begin TileToAdd:=3; FlipH:=0; FlipV:=0; end;
   6 : begin TileToAdd:=3; FlipH:=1; FlipV:=0; end;
   7 : begin TileToAdd:=4; FlipH:=0; FlipV:=0; end;
   8 : begin TileToAdd:=4; FlipH:=0; FlipV:=1; end;
   9 : begin TileToAdd:=6; FlipH:=0; FlipV:=0; end;
  10 : begin TileToAdd:=6; FlipH:=1; FlipV:=0; end;
  11 : begin TileToAdd:=6; FlipH:=0; FlipV:=1; end;
  12 : begin TileToAdd:=6; FlipH:=1; FlipV:=1; end;
  13 : begin TileToAdd:=1; FlipH:=0; FlipV:=0; end;
  14 : begin TileToAdd:=2; FlipH:=0; FlipV:=0; end;
   end;

if (WasAvailableTile=true) or (match<5) {or ((match>8) and (match<13))} then begin
   TerrainData [x]^[y]:=TileSet[TileToAdd];
   TerrainFlipH[x]^[y]:=FlipH;
   TerrainFlipV[x]^[y]:=FlipV;
   end;
end;
end;

procedure SetData ( x,y : word; tile : word; h,v : byte );
begin
   TerrainData[x]^[y]:=tile;
   TerrainFlipH[x]^[y]:=h;
   TerrainFlipV[x]^[y]:=v;
end;

{ =-      -====-       -= }
{========- MAIN -=========}
{ =-      -====-       -= }
procedure main;
var DrawMode : byte;
    MainDrawMode : byte;

    {MainDrawMode 4}
    CurrentlyGettingBrush : boolean;    {Right-click and hold}
    BrushStartX,BrushStartY : byte;     {Start of capture mode}
    bxa,bxb,bya,byb : byte;             {}

    CurrentTexture : byte;
    CurrentTexBaseSelect : byte;

    SingleTileMode : boolean;
    WideZoomMode : boolean;     ColorRange : byte;
                                CurrentRangePoint : byte;
    HeightMapActive : boolean;


    TexCurrentClass : byte;
    TexCurrent : byte;

    ReadyToDraw : boolean;
    LastX,LastY,LastButton,LastSelX,LastSelY : word;
    mouseselx,mousesely : integer;
    sh : integer;

    TempW,TempX,TempY : word;

    xa,xb,ya,yb : word;

    { Main Drawing Mode:
      1 - Map Edit Raise/Lower
      2 - Terrain Tile View }

procedure DrawModeInit;
begin
    case DrawMode of
    1 : begin
        ZoomScale:=4;
        RaiseLowerRadius := 5;
        end;
    2 : begin
        ZoomScale:=64;
        CurrentRangePoint:=1;
        RaiseLowerRadius := 1;
        WideZoomMode:=true;
        SingleTileMode:=true;
        end;
    end;
end;
procedure SetZoomScale(Zoom : byte);
begin
    case DrawMode of
    1 : ZoomScale:=Zoom;
    2 : case Zoom of
        1 : ZoomScale:=16;
        2 : ZoomScale:=32;
        3,4,5,6,7,8,9 : ZoomScale:=64;
        end;
    end;
end;

begin

{Initialize Modes/Options}
DrawMode:=2;
MainDrawMode:=1;
DrawModeInit;
MouseColor:=255;
{ZoomScale := 4;}
MapX := 1;   MapY := 1;
TexCurrentClass:=1;
TexCurrent:=1;
CurrentTexBaseSelect:=1;

CurrentlyGettingBrush:=false;

repeat  { Outer Loop - Main Loop - Exit upon Quitting }

repeat  { Draw Loop - Repeat until Input }

(*outtext(281,190,DrawModeName[DrawMode],255);*)

clr256;
MouseStatus;

case DrawMode of
1 : begin     { Map Raise/Lower - Shading Only }
    BuildGrayScale;  UpdateColorsFast(@Colors2);
    MouseSelY:=10000;
    if ZoomScale=1 then begin              { Draw Fully Zoomed Out }
        for x:=1 to 256 do
        for y:=1 to 198 do
        Pix(x+12,y,TerrainHeight[x]^[y]);
        end else
        begin                   { Draw At 2x2 Scale }
        if 256-mapx+1<280 div ZoomScale then mapx:=256-280 div ZoomScale+1;
        for x:=mapx to mapx+(280 div ZoomScale)-1 do
        for y:=mapy to mapy+(198 div ZoomScale)-1 do begin
        Bar( (x-mapx)*ZoomScale , (y-mapy)*ZoomScale ,
             (x-mapx)*ZoomScale+ZoomScale , (y-mapy)*ZoomScale+ZoomScale,
             TerrainHeight[x]^[y] );
        end;
    end;

    {Mouse Cursor Display}
    if (MouseX<MapXVisibleArea) then begin
        bar(MouseX div ZoomScale*ZoomScale  ,MouseY div ZoomScale*ZoomScale,
            MouseX div ZoomScale*ZoomScale+ZoomScale-1,MouseY div ZoomScale*ZoomScale+ZoomScale-1,
            MouseColor);
        if ZoomScale=1 then begin MouseSelX:=MouseX-12; MouseSelY:=MouseY; end else
        begin MouseSelX:=((MouseX) div ZoomScale)+MapX;
              MouseSelY:=((MouseY) div ZoomScale)+MapY; end;
    end else
        pix(MouseX,MouseY,MouseColor);

    end; {End DrawMode Case}

2 : begin
        UpdateColorsFast(@Palettes^[1]);

        if WideZoomMode then ColorRange:=12 else ColorRange:=6;

        {Draw Textures in Main Area}
        if 256-mapx+1<MapXVisibleArea div ZoomScale then mapx:=256-MapXVisibleArea div ZoomScale+1;
        for x:=mapx to mapx+(MapXVisibleArea div ZoomScale)-1 do
        for y:=mapy to mapy+(192 div ZoomScale)-1 do begin
        if HeightMapActive then
        sh:=(TerrainHeight[x]^[y]-CurrentRangePoint) * (3-byte(WideZoomMode) shl 1)
        else
        sh:=0;
        DrawTex    ( (x-mapx)*ZoomScale,(y-mapy)*ZoomScale,TerrainData[x]^[y],sh,ZoomScale,
                     boolean(TerrainFlipH[x]^[y]),boolean(TerrainFlipV[x]^[y]) );
        end;
        InitializeMapTileableMode(TexCurrentClass);

    {Mouse Cursor Display}
    if (MouseX<MapXVisibleArea div ZoomScale*ZoomScale) and (MouseY<192 div ZoomScale*ZoomScale) then begin
        MouseSelX:=MouseX div ZoomScale;
        MouseSelY:=MouseY div ZoomScale;

        {Cursor Size}
        case MainDrawMode of
        1,3 : begin
            tempx:=MouseSelX+1; tempy:=MouseSelY+1;
              end;
        2   : begin
            tempx:=MouseSelX+2; tempy:=MouseSelY+2;
            if tempx>(MapXVisibleArea div ZoomScale) then tempx:=MapXVisibleArea div ZoomScale;
            if tempy>(192 div ZoomScale) then tempy:=192 div ZoomScale;
              end;
        4   : begin
            if CurrentlyGettingBrush then begin
               tempx:=BrushStartX;
               tempy:=BrushStartY;
            end else begin
             if BrushXSize[TexCurrent]>0 then begin
                tempx:=MouseSelX+BrushXSize[TexCurrent];
                tempy:=MouseSelY+BrushYSize[TexCurrent];
                if tempx>(MapXVisibleArea div ZoomScale) then tempx:=MapXVisibleArea div ZoomScale;
                if tempy>(192 div ZoomScale) then tempy:=192 div ZoomScale;
             end else begin
                tempx:=MouseSelX+1;
                tempy:=MouseSelY+1;
                end;
            end;

              end;
        end;

        if MouseSelX<tempx then begin xa:=MouseSelX; xb:=tempx; end else
{        if MouseSelX=tempx then begin xa:=MouseSelX; xb:=xa+1; end else}
        begin xa:=tempx; xb:=MouseSelX end;

        if MouseSelY<tempy then begin ya:=MouseSelY; yb:=tempy; end else
{        if MouseSelY=tempy then begin ya:=MouseSelY; yb:=ya+1; end else}
        begin ya:=tempy; yb:=MouseSelY end;

        if (MainDrawMode=4) and (CurrentlyGettingBrush) then begin
           bxa:=xa; bxb:=xb; bya:=ya; byb:=yb;
           inc(yb); inc(xb);
           if bxb-bxa+1>=32 then bxb:=bxa+31;
           if byb-bya+1>=32 then byb:=bya+31;
           if MouseSelX<BrushStartX then
              begin xa:=BrushStartX-1; xb:=xa+1; bxa:=xa; bxb:=xa; end;
           if MouseSelY<BrushStartY then
              begin ya:=BrushStartY-1; yb:=ya+1; bya:=ya; byb:=ya; end;
           end;


        rectbrighten( (xa*ZoomScale),
                      (ya*ZoomScale),
                      (xb*ZoomScale)-1,
                      (yb*ZoomScale)-1 );
        rectbrighten( (xa*ZoomScale)+1,
                      (ya*ZoomScale)+1,
                      (xb*ZoomScale)-2,
                      (yb*ZoomScale)-2 );


(*        case MainDrawMode of
        1,3 : begin
        end;
        2 : begin
           { Fix : Absolute Lower Right X and Y }
         rectbrighten( (MouseSelX*ZoomScale),
                       (MouseSelY*ZoomScale),
                       (    tempx*ZoomScale)-1,
                       (    tempy*ZoomScale)-1 );
         rectbrighten( (MouseSelX*ZoomScale)+1,
                       (MouseSelY*ZoomScale)+1,
                       (    tempx*ZoomScale)-2,
                       (    tempy*ZoomScale)-2 );
         end;
        end;*)

        if HeightMapActive then begin
        font:=3;
        str(TerrainHeight[MouseSelX+mapx]^[MouseSelY+mapy],tempstr);
        outovertext( (MouseSelX)*ZoomScale+1-1,(MouseSelY)*ZoomScale-10  ,tempstr,0);
        outovertext( (MouseSelX)*ZoomScale+1+1,(MouseSelY)*ZoomScale-10  ,tempstr,0);
        outovertext( (MouseSelX)*ZoomScale+1  ,(MouseSelY)*ZoomScale-10-1,tempstr,0);
        outovertext( (MouseSelX)*ZoomScale+1  ,(MouseSelY)*ZoomScale-10+1,tempstr,0);
        outovertext( (MouseSelX)*ZoomScale+1  ,(MouseSelY)*ZoomScale-10  ,tempstr,254);
        end;
    end else

    {Mouse in Interface?}
    if (MouseX>=280) and (MouseX<=300) and (MouseY>=129) and (MouseY<=138) then begin
       MouseSelX:=990;   {Left Arrow}
       MouseSelY:=990;
    end else
    if (MouseX>=300) and (MouseX<=312) and (MouseY>=129) and (MouseY<=138) then begin
       MouseSelX:=991;   {Right Arrow}
       MouseSelY:=990;
    end else
    if (MouseX>280) and (MouseX<310) and (MouseY>137) and (MouseY<167) then begin
       MouseSelX:=990;   {Mode Selector Button}
       MouseSelY:=991;
    end else
    if (MouseX>=275) and (MouseX<=319) and (MouseY>=168) and (MouseY<=198) then begin
       MouseSelX:=900+(MouseX-275) div 15+1;
       MouseSelY:=900+(MouseY-168) div 15+1;
    end else

    if (MouseX>=0) and (MouseX<11+265) and (MouseY>192) then begin
       MouseSelY:=999;
       MouseSelX:=MouseX-11-6;  {Color Range = 6}
       if MouseSelX<0 then MouseSelX:=0;
       if MouseSelX+12>255 then MouseSelX:=255-12;
       RectBrighten(MouseSelX+11,193,MouseSelX+11+15,199);
       RectBrighten(MouseSelX+12,194,MouseSelX+10+15,198);
    end else
    if not (MouseX<MapXVisibleArea div ZoomScale*ZoomScale) then {Make sure on Right Region}
    begin

    {Right-Hand Brush/Texture Display}
    if (MouseX>=285) and (MouseX<=285+32) and
           (MouseY>=2)  and (MouseY<=2+16*8) then begin
           MouseSelX:=999;
           case MainDrawMode of
           1,2 : begin
           MouseSelY:=(MouseY-2) div 16+1;
           if MouseSelY>TexClassCount[TexCurrentClass] then begin MouseSelY:=10000; MouseSelX:=10000; end;
                 end;
           4   : begin
           MouseSelY:=(MouseY-2) div 32+1;
           if MouseSelY-1>BrushMax then begin MouseSelY:=10000; MouseSelX:=10000; end;
                 end;
           end;
    end else begin
        MouseSelY:=10000;
   if (MouseY=0) and (CurrentTexBaseSelect>1) then begin dec(CurrentTexBaseSelect); delay(ZoomScale+1); end;
   if (MouseY=199) then
      if ((MainDrawMode<3) and (CurrentTexBaseSelect<TexClassCount[TexCurrentClass]-4)) or
         ((MainDrawMode=4) and (CurrentTexBaseSelect<BrushMax-3)) then
      begin inc(CurrentTexBaseSelect); delay(4); end;
        end; {EndMouse}
    end;

    {Height Range View}
    rectangle(10,193,10+256+2,199,246);
    bar      (11,194,10+256+1,198,242);
    bar      (CurrentRangePoint+12-1,194,CurrentRangePoint+10+15-1,198,250);
    bar      (CurrentRangePoint+13-1,195,CurrentRangePoint+ 9+15-1,197,253);
    font:=3;
    str(CurrentRangePoint,tempstr);
    outovertext(CurrentRangePoint+12,190,tempstr,0);

        {Right-Hand Texture Display}
        case MainDrawMode of
        1,2 : begin
         for x:=1 to 8 do
           if x<=TexClassCount[TexCurrentClass] then
           DrawTex(285,x*16-14,TexClass[TexCurrentClass][X+CurrentTexBaseSelect-1],
                byte((MouseSelX=999) and (MouseSelY=X))*4,16,false,false);

         if (TexCurrent>=CurrentTexBaseSelect) and (TexCurrent<=CurrentTexBaseSelect+7) then begin
         X:=(TexCurrent-CurrentTexBaseSelect)*16;
         RectBrighten(285,X  +2,285+15,X+15+2);
         RectBrighten(286,X+1+2,285+14,X+14+2);
         end;
              end;
        4 :   begin
         DrawBrushIcon(0,283,1,byte((MouseSelX=999) and (MouseSelY=1))*4);
         if TexCurrent=0 then begin
           RectBrighten(282,0  ,284+31,0+31);
           RectBrighten(283,0+1,284+30,0+30);
         end;


         for x:=1 to 3 do
            DrawBrushIcon(x+CurrentTexBaseSelect-1,283,x*32+1,
            byte((MouseSelX=999) and (MouseSelY=X+1))*4);

           if (TexCurrent>=CurrentTexBaseSelect) and
              (TexCurrent<=CurrentTexBaseSelect+2) then begin
           X:=(TexCurrent-CurrentTexBaseSelect)*32+33;
           RectBrighten(282,X  ,284+31,X+31);
           RectBrighten(283,X+1,284+30,X+30);
           end;
          end;
        end;

           if (((MouseSelX=999) and (MouseSelY=1)) or ((MouseSelX=10000) and (BrushMax=0)) ) and (MainDrawMode=4) then
              NewDrawCShapeNum(1,13,300,20);
    {Draw Interface}

    {Main Icon}
    case MainDrawMode of
    1 : temp:=1;
    2 : temp:=2;
    3 : temp:=11;
    4 : temp:=12;
    end;
    NewDrawCShapeNum(1,temp,280,137);

    NewDrawCShapeNum(1,5,275,183);
    if WideZoomMode    then NewDrawCShapeNum(1,3,290,183) else NewDrawCShapeNum(1,4,290,183);
    if HeightMapActive then NewDrawCShapeNum(1,8,305,183) else NewDrawCShapeNum(1,7,305,183);

    case MainDrawMode of
    1,2 : begin NewDrawCShapeNum(1,9,280,130); NewDrawCShapeNum(1,10,296,130); end;
    end;

    pix(MouseX,MouseY,MouseColor);
    end;

end;

ShowVGA;
{delay(1);}

{Mouse Scrolling Around Map}
if not CurrentlyGettingBrush then
if drawmode=1 then begin
   if (MouseX=0) and (mapx>1) then begin dec(mapx); delay(ZoomScale div 2+1); end;
   if (MouseX=319) and (mapx<256) then begin inc(mapx); delay(ZoomScale div 2+1); end;
   if (MouseY=0) and (mapy>1) then begin dec(mapy); delay(ZoomScale div 2+1); end;
   if (MouseY=199) and (mapy<256) then begin inc(mapy); delay(ZoomScale div 2+1); end;
end else begin
   if (MouseX=0) and (mapx>1) then begin dec(mapx); delay(ZoomScale+1); end;
   if (MouseX=319) and (mapx<256) then begin inc(mapx); delay(ZoomScale+1); end;
   if (MouseX<MapXVisibleArea div ZoomScale*ZoomScale) then begin
   if (MouseY=0) and (mapy>1) then begin dec(mapy); delay(ZoomScale+1); end;
    if (MouseY=199) and (mapy<256) then begin inc(mapy); delay(ZoomScale+1); end;
    end;
end;

if MouseButton=0 then begin LastButton:=0; LastSelX:=10000; LastSelY:=10000;
   if CurrentlyGettingBrush then begin
      { Copy from Map to TempBrush [0] }
      for xa:=1 to bxb-bxa+1 do
      for ya:=1 to byb-bya+1 do begin
      Brush     [0]^[xa,ya]:=TerrainData [xa+bxa+mapx-1]^[ya+bya+mapy-1];
      BrushFlipH[0]^[xa,ya]:=TerrainFlipH[xa+bxa+mapx-1]^[ya+bya+mapy-1];
      BrushFlipV[0]^[xa,ya]:=TerrainFlipV[xa+bxa+mapx-1]^[ya+bya+mapy-1];
      end;
      BrushXSize[0]:=bxb-bxa+1;
      BrushYSize[0]:=byb-bya+1;
      CurrentlyGettingBrush:=false;
      TexCurrent:=0;
   end;
end;
Keypress := Keypressed(k);

until ((MouseButton>0) or Keypress)
   and not (CurrentlyGettingBrush);

if Keypress then begin
case upcase(k) of
'1' : SetZoomScale(1);
'2' : SetZoomScale(2);
'3' : SetZoomScale(3);
'4' : SetZoomScale(4);
'5' : SetZoomScale(5);
'6' : SetZoomScale(6);
'7' : SetZoomScale(7);
'8' : SetZoomScale(8);
'9' : SetZoomScale(9);
'H' : if (MainDrawMode=4) and (BrushXSize[TexCurrent]>0) then begin {Rotate Brush}
      for x:=1 to BrushXSize[TexCurrent] do
      for y:=1 to BrushYSize[TexCurrent] do begin
      tempw:=Brush     [TexCurrent]^[x,y];
      Brush     [101]^[BrushXSize[TexCurrent]-x+1,y]:=tempw;
       if tempw>0 then begin
       BrushFlipH[101]^[BrushXSize[TexCurrent]-x+1,y]:=byte(not boolean(byte(BrushFlipH[TexCurrent]^[x,y])));
       BrushFlipV[101]^[BrushXSize[TexCurrent]-x+1,y]:=byte(boolean(byte(BrushFlipV[TexCurrent]^[x,y])));
       end else begin
       BrushFlipH[101]^[BrushXSize[TexCurrent]-x+1,y]:=BrushFlipH[TexCurrent]^[x,y];
       BrushFlipV[101]^[BrushXSize[TexCurrent]-x+1,y]:=BrushFlipV[TexCurrent]^[x,y];
       end;
      end;
      Brush     [TexCurrent]^:=Brush[101]^;
      BrushFlipH[TexCurrent]^:=BrushFlipH[101]^;
      BrushFlipV[TexCurrent]^:=BrushFlipV[101]^;
      end;
'V' : if (MainDrawMode=4) and (BrushXSize[TexCurrent]>0) then begin {Rotate Brush}
      for x:=1 to BrushXSize[TexCurrent] do
      for y:=1 to BrushYSize[TexCurrent] do begin
      tempw:=Brush     [TexCurrent]^[x,y];
      Brush     [101]^[x,BrushYSize[TexCurrent]-y+1]:=tempw;
       if tempw>0 then begin
       BrushFlipH[101]^[x,BrushYSize[TexCurrent]-y+1]:=byte(boolean(byte(BrushFlipH[TexCurrent]^[x,y])));
       BrushFlipV[101]^[x,BrushYSize[TexCurrent]-y+1]:=byte(not boolean(byte(BrushFlipV[TexCurrent]^[x,y])));
       end else begin
       BrushFlipH[101]^[x,BrushYSize[TexCurrent]-y+1]:=BrushFlipH[TexCurrent]^[x,y];
       BrushFlipV[101]^[x,BrushYSize[TexCurrent]-y+1]:=BrushFlipV[TexCurrent]^[x,y];
       end;
      end;
      Brush     [TexCurrent]^:=Brush[101]^;
      BrushFlipH[TexCurrent]^:=BrushFlipH[101]^;
      BrushFlipV[TexCurrent]^:=BrushFlipV[101]^;
      end;
#9  : { TAB key - Change Mode }
      begin inc(DrawMode); if DrawMode>2 then DrawMode:=1;
      clr256; showvga; DrawModeInit; end;
'{' : begin dec(TexCurrentClass);
      if TexCurrentClass<1 then TexCurrentClass:=TexClassMax;
      end;
'}' : begin inc(TexCurrentClass);
      if TexCurrentClass>TexClassMax then TexCurrentClass:=1;
      end;
end;

if not CurrentlyGettingBrush then
case scancode of
72 : if mapy>1   then dec(mapy);
80 : if mapy<256 then inc(mapy);
75 : if mapx>1   then dec(mapx);
77 : if mapx<256 then inc(mapx);
end;

end;


{ Perform Draw Functions }
if (MouseSelX<>LastSelX) or (MouseSelY<>LastSelY) then
case DrawMode of
1 : if (MouseSelX>=0) and (MouseSelX<256) and (MouseSelY>=0) and (MouseSelY<256) then
    begin
    if MouseButtons[1] then ChangeTerrain(MouseSelX,MouseSelY, 1);
    if MouseButtons[2] then ChangeTerrain(MouseSelX,MouseSelY,-1);
    end;
2 :
    {Add Brush to List}
    if (((MouseSelX=999) and (MouseSelY=1)) or ((MouseSelX=10000) and (BrushMax=0)) ) and (MainDrawMode=4) then begin
        if BrushXSize[0]>0 then begin
        inc(BrushMax);
        new(Brush[BrushMax]); new(BrushFlipH[BrushMax]); new(BrushFlipV[BrushMax]);
        Brush[BrushMax]^     :=Brush[0]^;
        BrushFlipH[BrushMax]^:=BrushFlipH[0]^;
        BrushFlipV[BrushMax]^:=BrushFlipV[0]^;
        BrushXSize[BrushMax] :=BrushXSize[0];
        BrushYSize[BrushMax] :=BrushYSize[0];
        BrushXSize[0]:=0;
        TexCurrent:=BrushMax;
        CurrentTexBaseSelect:=TexCurrent;
        end;
    end else
    if (MouseSelX=999) then begin  {Select Right-Hand Side}
    if MouseButtons[1] then begin
    TexCurrent:=MouseSelY+CurrentTexBaseSelect-1;
    if MainDrawMode=4 then dec(TexCurrent);
    end else
    if MainDrawMode=4 then DeleteBrush(MouseSelY+CurrentTexBaseSelect-2);
    end else
    if (MouseSelY=999) then begin  {Select Palette Range Slider}
    CurrentRangePoint:=MouseSelX;
    end else
    if (MouseSelX>900) and (MouseSelY>900) then begin
{       if (MouseSelX=901) and (MouseSelY=901) and Tileable then SingleTileMode:= not SingleTileMode;}
       if (MouseSelX=901) and (MouseSelY=902) then begin
          if MouseButtons[1] then if ZoomScale>4  then ZoomScale:=ZoomScale shr 1;
          if MouseButtons[2] then if ZoomScale<64 then ZoomScale:=ZoomScale shl 1;
       end;
       if (MouseSelX=902) and (MouseSelY=902) then WideZoomMode:= not WideZoomMode;
       if (MouseSelX=903) and (MouseSelY=902) then HeightMapActive:=not HeightMapActive;
       if (MouseSelX=990) and (MouseSelY=990) then begin
          dec(TexCurrentClass);
          if TexCurrentClass<1 then TexCurrentClass:=TexClassMax;
          end;
       if (MouseSelX=991) and (MouseSelY=990) then begin
          inc(TexCurrentClass);
          if TexCurrentClass>TexClassMax then TexCurrentClass:=1;
          end;
       if (MouseSelX=990) and (MouseSelY=991) then begin
          if MouseButtons[1] then begin dec(MainDrawMode); if MainDrawMode<1 then MainDrawMode:=4; end;
          if MouseButtons[2] then begin inc(MainDrawMode); if MainDrawMode>4 then MainDrawMode:=1; end;
          end;
    end else
    if (MouseSelX>=0) and (MouseSelX<256) and (MouseSelY>=0) and (MouseSelY<256) then
    begin
    if MouseButtons[1] then
       Case MainDrawMode of
       1 : TerrainData[MouseSelX+Mapx]^[MouseSelY+Mapy]:=TexClass[TexCurrentClass][TexCurrent];
       2 : begin
        SetSmoothingTile(MouseSelX+Mapx,MouseSelY+Mapy,Tileset[5],1,0);
        if x<256 then begin
        SetSmoothingTile(MouseSelX+1+Mapx,MouseSelY+Mapy,Tileset[5],0,0);
        end;
        if y<256 then begin
        SetSmoothingTile(MouseSelX+Mapx,MouseSelY+1+Mapy,Tileset[5],1,1);
        end;
        if (x<256) and (y<256) then begin
        SetSmoothingTile(MouseSelX+1+Mapx,MouseSelY+1+Mapy,Tileset[5],0,1);
        end;
        {closevga256;}

        for x:=mouseselx+mapx to mouseselx+mapx+1 do
        for y:=mousesely+mapy to mousesely+mapy+1 do
        DrawSmoothingTile(x,y);

        DrawSmoothingTile(x-1,y  );
        DrawSmoothingTile(x-1,y+1);
        DrawSmoothingTile(x  ,y+2);
        DrawSmoothingTile(x+1,y+2);
        DrawSmoothingTile(x+2,y  );
        DrawSmoothingTile(x+2,y+1);
        DrawSmoothingTile(x  ,y-1);
        DrawSmoothingTile(x+1,y-1);

        for x:=mouseselx+mapx-2 to mouseselx+mapx+3 do
        for y:=mousesely+mapy-2 to mousesely+mapy+3 do
        DrawSmoothingTile(x,y);
        for x:=mouseselx+mapx-2 to mouseselx+mapx+3 do
        for y:=mousesely+mapy-2 to mousesely+mapy+3 do
        DrawSmoothingTile(x,y);

{        for x:=mouseselx+mapx-1 to mouseselx+mapx+2 do
        for y:=mousesely+mapy-1 to mousesely+mapy+2 do
        DrawSmoothingTile(x,y);}

        {initvga256;}
        end;
       3 : ChangeTerrain(MouseSelX+Mapx,MouseSelY+Mapy, 1);
       4 : begin  {Copy Brush to Map}
        if BrushXSize[TexCurrent]>0 then
        for xa:=1 to BrushXSize[TexCurrent] do
        for ya:=1 to BrushYSize[TexCurrent] do begin
        TerrainData [xa+MouseSelX+mapx-1]^[ya+MouseSelY+mapy-1]:=Brush     [TexCurrent]^[xa,ya];
        TerrainFlipH[xa+MouseSelX+mapx-1]^[ya+MouseSelY+mapy-1]:=BrushFlipH[TexCurrent]^[xa,ya];
        TerrainFlipV[xa+MouseSelX+mapx-1]^[ya+MouseSelY+mapy-1]:=BrushFlipV[TexCurrent]^[xa,ya];
        end;
{        BrushXSize[BrushMax]:=bxb-bxa+1;
        BrushYSize[BrushMax]:=byb-bya+1;}
           end;
       end;
    if MouseButtons[2] then
    Case MainDrawMode of
       1 : begin
        temp :=byte(not boolean(TerrainFlipH[MouseSelX+Mapx]^[MouseSelY+Mapy]));
        temp2:=TerrainFlipV[MouseSelX+Mapx]^[MouseSelY+Mapy];
        if (temp=temp2) then begin
        TerrainFlipV[MouseSelX+Mapx]^[MouseSelY+Mapy]:=byte(not boolean(TerrainFlipV[MouseSelX+Mapx]^[MouseSelY+Mapy]));
        temp:=byte(not boolean(temp));
        end;
        TerrainFlipH[MouseSelX+Mapx]^[MouseSelY+Mapy]:=temp;
        end;
       2 : begin
        SetData(MouseSelX+MapX,MouseSelY+MapY,TileSet[5],0,1);
        if x<256 then begin
        SetData(MouseSelX+MapX+1,MouseSelY+MapY,TileSet[5],1,1);
        end;
        if y<256 then begin
        SetData(MouseSelX+MapX,MouseSelY+MapY+1,TileSet[5],0,0);
        end;
        if (x<256) and (y<256) then begin
        SetData(MouseSelX+MapX+1,MouseSelY+MapY+1,TileSet[5],1,0);
        end;
        for x:=mouseselx+mapx to mouseselx+mapx+1 do
        for y:=mousesely+mapy to mousesely+mapy+1 do
        DrawSmoothingTile(x,y);

{        DrawSmoothingTile(x-1,y  );
        DrawSmoothingTile(x-1,y+1);
        DrawSmoothingTile(x  ,y+2);
        DrawSmoothingTile(x+1,y+2);
        DrawSmoothingTile(x+2,y  );
        DrawSmoothingTile(x+2,y+1);
        DrawSmoothingTile(x  ,y-1);
        DrawSmoothingTile(x+1,y-1);}

        for x:=mouseselx+mapx-1 to mouseselx+mapx+2 do
        for y:=mousesely+mapy-1 to mousesely+mapy+2 do
        DrawSmoothingTile(x,y);
        end;
       3 : ChangeTerrain(MouseSelX+Mapx,MouseSelY+Mapy,-1);
       4 : begin
        if brushmax<100 then begin
        BrushStartX:=MouseSelX;
        BrushStartY:=MouseSelY;
        CurrentlyGettingBrush:=true;
        end;
           end;
    end;
   end;
end;

LastX:=MouseX;  LastY:=MouseY;  LastButton:=MouseButton;
LastSelX:=MouseSelX; LastSelY:=MouseSelY;

until (MouseButton=3);
end;

begin

NewLoadShapes(1,'ESTTE.SHP');

Colors2:=Palettes^[1];
LoadAllTex;

{Initialize Terrain}
for x:=1 to 256 do new(TerrainHeight[x]);
for x:=1 to 256 do for y:=1 to 256 do TerrainHeight[x]^[y]:=0;
for x:=1 to 256 do new(TerrainFlipH[x]);
for x:=1 to 256 do for y:=1 to 256 do TerrainFlipH[x]^[y]:=0;
for x:=1 to 256 do new(TerrainFlipV[x]);
for x:=1 to 256 do for y:=1 to 256 do TerrainFlipV[x]^[y]:=0;
for x:=1 to 256 do new(TerrainData[x]);
for x:=1 to 256 do for y:=1 to 256 do TerrainData[x]^[y]:=0;

initvga256;
new(VGAScreen2);

main;

closevga256;
dispose(VGAScreen);
dispose(VGAScreen2);

{Remove Terrain}
for x:=1 to 256 do dispose(TerrainHeight[x]);
for x:=1 to 256 do dispose(TerrainFlipH[x]);
for x:=1 to 256 do dispose(TerrainFlipV[x]);
for x:=1 to 256 do dispose(TerrainData[x]);

{PALLIB - Remove palettes}
dispose(palettes);

SaveBrushes;
for x:=0 to 100 do if brush[x]<>nil then begin
   dispose(brush[x]);
   dispose(brushfliph[x]);
   dispose(brushflipv[x]);
end;

end.